<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>

  <div class="container">
    <h2 style="text-align: center;">Danh sách người dùng</h2>

    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>
  <script>
    $(document).ready(function () {
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      var gJsonUsers = `{
      "description": "Data user",
      "users": [
        {
          "userId": 1,
          "firstname": "Test1",
          "lastname": "User1",
          "age": 18
        },
        {
          "userId": 2,
          "firstname": "Test2",
          "lastname": "User2",
          "age": 19
        },
        {
          "userId": 3,
          "firstname": "Test3",
          "lastname": "User3",
          "age": 18
        },
        {
          "userId": 4,
          "firstname": "Test4",
          "lastname": "User4",
          "age": 20
        },
        {
          "userId": 5,
          "firstname": "Test5",
          "lastname": "User5",
          "age": 21
        },
        {
          "userId": 6,
          "firstname": "Test6",
          "lastname": "User6",
          "age": 20
        }
      ]
    }`;

      var gJsonUsersObject = JSON.parse(gJsonUsers);

      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoading();

      $("#user-table").on("click",".user-detail",function(){
        onBtnUserDetailClick(this);
      })

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        /* Hãy đổ dữ liệu vào table và thực hiện nút information (chi tiết)
         * dùng cách khai báo data source ngay từ đầu */
        $("#user-table").DataTable({
          data: gJsonUsersObject.users,
          columns: [
            { data: 'userId' },
            { data: 'firstname' },
            { data: 'lastname' },
            { data: 'age' }
          ],
          columnDefs: [
            { 
              targets: [0], 
              visible: true,
              className : 'text-center text-primary'
            },
            { 
              targets: [3], 
              visible: true,
              className : 'text-right',
              render : function (data, type){
                return data + " tuổi";
              }
            },
            { 
              targets: [4], 
              visible: true,
              className : 'text-center',
              defaultContent : "<button class='btn btn-info user-detail'>Chi tiết</button>"
            }
          ]
        });
      }

      function onBtnUserDetailClick(paramButton){
        var vUserTable = $("#user-table").DataTable();
        var vTableRow = $(paramButton).parents("tr");
        var vRow = vUserTable.row(vTableRow);
        var vRowData = vRow.data();
        console.log("User Id : " + vRowData.userId);
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    })

  </script>
</body>

</html>